#include <built_in.h>

void key1_lp(void);
void key3_lp(void);
void key1_sp(void);
void key2_sp(void);
void key3_sp(void);
void key4_sp(void);
void key5_sp(void);
void key_press(void);
void PrintCorr(void);
void timer_start(void);
void PrintAlrm(void);
void PrintTime(void);
void MoveCur(short);
volatile char key_press_flag = 0;
volatile char seconds0_flag = 0;
short seconds0 = 0;
char keys = 0;
char setup_time = 0;
char setup_corr = 0;
short cursor_pos = 10;
short cursor_posA = 4;
short minutes0 = 0;
short hours0 = 0;
short alrmI_minutes = 0;
short alrmI_hours = 0;
short alrmO_minutes = 0;
short alrmO_hours = 0;
char alrm_flag = 0;
short corr;
short corr_sec = 0;
char time0[] = "00:00:00";
char alrmI[] = "I 00:00";
char alrmO[] = "O 00:00";
char i;
char setup_alrm = 0;

sbit LCD_RS at PORTC.B0;
sbit LCD_EN at PORTC.B1;
sbit LCD_D4 at PORTC.B2;
sbit LCD_D5 at PORTC.B3;
sbit LCD_D6 at PORTC.B4;
sbit LCD_D7 at PORTC.B5;

sbit LCD_RS_Direction at TRISC.B0;
sbit LCD_EN_Direction at TRISC.B1;
sbit LCD_D4_Direction at TRISC.B2;
sbit LCD_D5_Direction at TRISC.B3;
sbit LCD_D6_Direction at TRISC.B4;
sbit LCD_D7_Direction at TRISC.B5;

void main()
{
ANSEL = 0x0;//no analog inputs
CMCON0 |= 0x07; //PORTA bits 0-3 read as digital (Comparators OFF)
TRISC = 0x00;//PORTC all bits as outputs
PORTC = 0x00;
TRISA = 0x3E;//RA0 as output, RA1-5, as inputs
PORTA &= 0x30;//  RA0-3
PORTA |= 0x30;//  4-5     32768
IOCA = 0x0E;//interrupt-on-change enable on bits RA1-3

corr = EEPROM_Read(0);
if(abs(corr)>99)
  corr = 0;

//alrmI_minutes = EEPROM_Read(1);
//if(alrmI_minutes>59 || alrmI_minutes<0)
//  alrmI_minutes = 0;
//alrmI_hours = EEPROM_Read(2);
//if(alrmI_hours>23 || alrmI_hours<0)
//  alrmI_hours = 0;

//alrmO_minutes = EEPROM_Read(3);
//if(alrmO_minutes>59 || alrmO_minutes<0)
//  alrmO_minutes = 0;
//alrmO_hours = EEPROM_Read(4);
//if(alrmO_hours>23 || alrmO_hours<0)
//  alrmO_hours = 0;

Lcd_Init();            // Initialize LCD
Lcd_Cmd(_LCD_CLEAR);      // Clear display
Lcd_Cmd(_LCD_CURSOR_OFF);      // Cursor off
PrintAlrm();
Lcd_Out(2,9,time0);

INTCON = 0xC8;//Global, PEIE interrupts enable, RA interrupts enable, RA interrupt bit reset

timer_start();

while (1)
 {
 if (seconds0_flag && !setup_time && !setup_corr)
  {
  corr_sec = 5;//      
  seconds0++;
  if (seconds0 >= 60)
    {
    minutes0++;
    seconds0 = 0;
    corr_sec = corr - 8;//      
    }
  if (minutes0 >= 60)
    {
    hours0++;
    minutes0 = 0;
    }
  if (hours0 >= 24)
    hours0 = 0;

  if(!setup_alrm)
    {
    if(/*(alrmI_hours || alrmI_minutes) && */!alrm_flag)
      alrm_flag = !((alrmI_hours - hours0) || (alrmI_minutes - minutes0));

    if(/*(alrmO_hours || alrmO_minutes)  && */alrm_flag)
      alrm_flag = ((alrmO_hours - hours0) || (alrmO_minutes - minutes0));

    if(alrm_flag)
      {
      PORTA.B0 = 1;
      Lcd_Chr(1,8,0x2A);
      }
    else
      {
      PORTA.B0 = 0;
      Lcd_Chr(1,8,0x20);
      }
    PrintTime();
    asm sleep;
    goto end;
    }

  seconds0_flag = 0;
  }

 end:

 if (key_press_flag)
  key_press();

 if (keys)
  {
  switch(keys)
    {
    case 0x01: key1_lp(); break;
    case 0x03: key3_lp(); break;
    /*case 0x04:
      while(PORTA & 0x0E)
        {
        key4_sp();
        Delay_ms(300);
        }
      break;
    case 0x05:
      while(PORTA & 0x0E)
        {
        key5_sp();
        Delay_ms(300);
        }
      break;*/
    case 0x11: key1_sp(); break;
    case 0x12: key2_sp(); break;
    case 0x13: key3_sp(); break;
    case 0x14: key4_sp(); break;
    case 0x15: key5_sp();
    }
  keys = 0;
  }
 }
}

void interrupt()
{
INTCON.GIE = 0;//Global interrupts disable
if (PIR1)
 {
 PIE1 = 0;
 T1CON &= 0xFE;//Stop timer1
 seconds0_flag = 1;
 timer_start();
 }

else
 if (INTCON.RAIF)
 {
 INTCON.RAIE = 0;
 key_press_flag = 1;
 seconds0_flag = 0;
 }
INTCON.GIE = 1;//Global interrupts enable
}

void key_press()
{
Delay_ms(20);
keys = (PORTA & 0x0E) >> 1;
if (! keys)
 goto end;
for (i=0; i<10; i++)
 {
 Delay_ms(100);//    
 if(!(PORTA & 0x0E))//  ,   
  {
  keys |= 0x10;
  break;
  }
 }

end:
key_press_flag = 0;
INTCON.RAIF = 0;//RB change interrupt bit reset
INTCON.RAIE = 1;
}

void key1_lp()//Set time
{
if(setup_corr || setup_alrm)
  return;
if(!setup_time)
  {
  setup_time = 1;
  T1CON &= 0xFE;//Stop timer1

  Lcd_Cmd(_LCD_BLINK_CURSOR_ON); // Cursor blink on
  Lcd_Out(2,1,"SetTm");
  MoveCur(cursor_pos-6);
  }
else
  {
  Lcd_Out(2,1,"     ");
  seconds0_flag = 0;
  setup_time = 0;
  Lcd_Cmd(_LCD_CURSOR_OFF);      // Cursor off
  timer_start();
  }
}

void key3_lp()//Set clock correction
{
if(setup_time || setup_alrm)
  return;
if(!setup_corr)
  {
  setup_corr = 1;
  T1CON &= 0xFE;//Stop timer1

  Lcd_Cmd(_LCD_BLINK_CURSOR_ON); // Cursor blink on
  PrintCorr();
  }
else
  {
  EEPROM_Write(0, corr);
  Lcd_Out(2,1,"       ");
  setup_corr = 0;
  Lcd_Cmd(_LCD_CURSOR_OFF);      // Cursor off
  timer_start();
  }
}

void key1_sp() //Set alarms
{
if(setup_corr || setup_time)
  return;
if(!setup_alrm)
  {
  seconds0_flag = 0;
  setup_alrm = 1;
  Lcd_Out(2,1,"SetAlm");
  Lcd_Cmd(_LCD_BLINK_CURSOR_ON); // Cursor blink on
  Lcd_Cmd(_LCD_FIRST_ROW);
  MoveCur(cursor_posA-1);
  }
else
  {
  setup_alrm = 0;
  Lcd_Out(2,1,"      ");
  Lcd_Cmd(_LCD_CURSOR_OFF);
  //EEPROM_Write(1, alrmI_minutes);
  //EEPROM_Write(2, alrmI_hours);
  //EEPROM_Write(3, alrmO_minutes);
  //EEPROM_Write(4, alrmO_hours);
  }
}

void key2_sp()//move cursor left
{
if(setup_time)
  {
  cursor_pos-=3;
  if(cursor_pos < 10)
    {
    cursor_pos = 10;
    return;
    }
  MoveCur(-3);
  }

if(setup_alrm)
  {
  switch(cursor_posA)
    {
    case 7:
      cursor_posA = 4;
      MoveCur(-3);
      break;
    case 13:
      cursor_posA = 7;
      MoveCur(-6);
      break;
    case 16:
      cursor_posA = 13;
      MoveCur(-3);

    }
  }
}

void key3_sp()//move cursor right
{
if(setup_time)
  {
  cursor_pos+=3;
  if(cursor_pos > 16)
    {
    cursor_pos = 16;
    return;
    }
  MoveCur(3);
  }

if(setup_alrm)
  {
  switch(cursor_posA)
    {
    case 13:
      cursor_posA = 16;
      MoveCur(3);
      break;
    case 7:
      cursor_posA = 13;
      MoveCur(6);
      break;
    case 4:
      cursor_posA = 7;
      MoveCur(3);
    }
  }
}

void key4_sp()//parameter up
{
if(setup_time)
 {
 switch(cursor_pos)
  {
  case 10:
    if(++hours0>=24) hours0=0;
    break;
  case 13:
    if(++minutes0>=60) minutes0=0;
    break;
  case 16:
    if(++seconds0>=60) seconds0=0;
  }
 PrintTime();
 }

if(setup_corr)
 {
 if(++corr > 99)
   corr = 99;
 PrintCorr();
 }

if(setup_alrm)
 {
 switch(cursor_posA)
  {
  case 4:
    if(++alrmI_hours>=24) alrmI_hours=0;
    break;
  case 7:
    if(++alrmI_minutes>=60) alrmI_minutes=0;
    break;
  case 13:
    if(++alrmO_hours>=24) alrmO_hours=0;
    break;
  case 16:
    if(++alrmO_minutes>=60) alrmO_minutes=0;
  }
 PrintAlrm();
 }
}

void key5_sp()//parameter down
{
if(setup_time)
 {
 switch(cursor_pos)
  {
  case 10:
    if(--hours0<0) hours0=23;
    break;
  case 13:
    if(--minutes0<0) minutes0=59;
    break;
  case 16:
    if(--seconds0<0) seconds0=59;
  }
 PrintTime();
 }

if(setup_corr)
 {
 if(--corr < -99)
   corr = -99;
 PrintCorr();
 }

if(setup_alrm)
 {
 switch(cursor_posA)
  {
  case 4:
    if(--alrmI_hours<0) alrmI_hours=23;
    break;
  case 7:
    if(--alrmI_minutes<0) alrmI_minutes=59;
    break;
  case 13:
    if(--alrmO_hours<0) alrmO_hours=23;
    break;
  case 16:
    if(--alrmO_minutes<0) alrmO_minutes=59;
  }
 PrintAlrm();
 }
}

void PrintCorr()
{
Lcd_Out(2,1,"COR=");
if(corr<0)
  Lcd_Chr_CP(0x2D);
else Lcd_Chr_CP(0x2B);
Lcd_Chr_CP(0x30+(char)(abs(corr)/10));
Lcd_Chr_CP(0x30+(char)(abs(corr)%10));
Lcd_Cmd(_LCD_MOVE_CURSOR_LEFT);
}

void timer_start()
{
unsigned int reg_tmr = 0x8000 + corr_sec;

PIR1 = 0;
TMR1H = Hi(reg_tmr);
TMR1L = Lo(reg_tmr);
corr_sec = 0;

T1CON = 0x0F;//Prescaler set to 1/1, start timer1

PIE1 = 1;
}

void PrintAlrm()
{
alrmI[2] = 0x30 + (short)alrmI_hours/10;
alrmI[3] = 0x30 + alrmI_hours%10;
alrmI[5] = 0x30 + (short)alrmI_minutes/10;
alrmI[6] = 0x30 + alrmI_minutes%10;

alrmO[2] = 0x30 + (short)alrmO_hours/10;
alrmO[3] = 0x30 + alrmO_hours%10;
alrmO[5] = 0x30 + (short)alrmO_minutes/10;
alrmO[6] = 0x30 + alrmO_minutes%10;

Lcd_Out(1,1,alrmI);            // Write text in 1 row
Lcd_Out(1,10,alrmO);           // Write text in 1 row
if(alrm_flag)
  Lcd_Chr(1,8,0x2A);
else Lcd_Chr(1,8,0x20);
Lcd_Cmd(_LCD_RETURN_HOME);
MoveCur(cursor_posA-1);
}

void PrintTime()
{
time0[0] = 0x30 + (short)hours0/10;
time0[1] = 0x30 + hours0%10;
time0[3] = 0x30 + (short)minutes0/10;
time0[4] = 0x30 + minutes0%10;
time0[6] = 0x30 + (short)seconds0/10;
time0[7] = 0x30 + seconds0%10;
Lcd_Out(2,9,time0);
MoveCur(cursor_pos-17);
}

void MoveCur(short j)
{
if(j>0)
  {
  for (i=0;i<j;i++)
    Lcd_Cmd(_LCD_MOVE_CURSOR_RIGHT);
  }

if(j<0)
  {
  for (i=0;i<abs(j);i++)
    Lcd_Cmd(_LCD_MOVE_CURSOR_LEFT);
  }
}